
;;
;;          :
;;   ( )
;;   3.4 = 0.34*10^1 = (34 1) 
;;

(setq *sfamsize* 30) ;;   ( )

;;    

(csetq ZERO     '(0 0))
(csetq ONE      '(1 1)) 
(csetq TWO      '(2 1))
(csetq THREE    '(3 1))
(csetq FOUR     '(4 1))
(csetq FIVE     '(5 1))
(csetq SIX      '(6 1))
(csetq SEVEN    '(7 1))
(csetq EIGHT    '(8 1))
(csetq NINE     '(9 1))
(csetq TEN      '(1 2))
(csetq TWENTY   '(2 2))
(csetq THIRTY   '(3 2))
(csetq FOURTY   '(4 2))
(csetq FIFTY    '(5 2))
(csetq SIXTY    '(6 2))
(csetq SEVETY   '(7 2))
(csetq EIGHTY   '(8 2))
(csetq NINETY   '(9 2))
(csetq HUNDRED  '(1 3))
(csetq THOUSAND '(1 4))

;;                    1         2         3         4         5         6         7         8         9         1
;;           123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901   

(setq *pi* '(314159265358979323846264338327950288419716939937510582097494459230781640628620899862803482534211706798214808651 1))
(setq *e*  '(271828182845904523536028747135266249775724709369995957496696762772407663035354759457138217852516642742746639193 1))

;;   

(defun sfaSetsize (n)
  (setq *sfamsize* n))

;;   (  m)

(defun sfaTrunc (m) 
   (let* ((ms (fix2str m))
          (l  (strLen ms))
          (mr "")
          (tr ""))
      (cond ((<= l *sfamsize*) (str2fix (strCat ms (strString (- *sfamsize* l) (strAsc "0")))))
            (t (setq mr (strLeft ms *sfamsize*) tr (strMid ms (+ *sfamsize* 1) 1))
               (if (>= (strCmp tr "5") 0) (+ 1 (str2fix mr)) (str2fix mr))))))

;;    m 

(defun sfaRound (x m)
  (let* ((ma (car x))
         (p  (cadr x))
         (ms (fix2str ma))
         (lm (strLen ms))
         (mr "")
         (tr ""))
       (cond ((<= lm m) (setq mr (str2fix (strCat ms (strString (- m lm) (strAsc "0"))))))
             (t (setq mr (strLeft ms m) tr (strMid ms (+ m 1) 1))
                (setq mr (if (>= (strCmp tr "5") 0) (+ 1 (str2fix mr)) (str2fix mr)))))
       (list mr p)))         

;;   

(defun sfaFix (x)
  (let* ((ma (car x))
         (p  (cadr x))
         (ms (fix2str ma))
         (mm "")
         (tt "")
         (mr 0))
    (if (<= p 0) (list 0 0)
        (progn
           (setq mm (strLeft ms p) tt (strMid ms (+ p 1) 1))
           (if (>= (strCmp tt "5") 0) (setq mr (+ 1 (str2fix mm))) (setq mr (str2fix mm)))
           (list mr p)))))     

;;    ( )

(defun sfaPrint (f)
  (let* ((m  (nth 0 f))
         (p  (nth 1 f))
         (s  (sign m))
         (ma (sfaTrunc (abs m))))
        (if (minusp s) (prints "-") (prints " "))
        (prints "0.") (print ma) (prints "e") (print p) t))        

;;     

(defun sfaOutput (f)
  (let* ((m  (nth 0 f))
         (p  (nth 1 f))
         (s  (sign m))
         (ma (sfaTrunc (abs m))))
        (strcat (if (minusp s) "-" " ") "0." (fix2str ma) "e" (fix2str p))))

;;    

(defun sfaNeg (f)
  (cons (- (nth 0 f)) (cdr f)))

;;  

(defun sfaAdd (f1 f2)
  (let* ((m1   (nth 0 f1))
         (m2   (nth 0 f2))
         (p1   (nth 1 f1))
         (p2   (nth 1 f2))
         (dp   0)
         (s1   (sign m1))
         (s2   (sign m2))
         (sr   1)
         (ma1  (sfaTrunc (abs m1)))
         (ma2  (sfaTrunc (abs m2)))
         (pr   (max p1 p2)) 
         (mar  0))
         (cond ((> p1 p2) (setq dp (- p1 p2) ma1 (str2fix (strCat (fix2str ma1) (strString dp (strAsc "0"))))))
               ((> p2 p1) (setq dp (- p2 p1) ma2 (str2fix (strCat (fix2str ma2) (strString dp (strAsc "0")))))))
    (when (minusp s1) (setq ma1 (- ma1)))
    (when (minusp s2) (setq ma2 (- ma2)))   
    (setq mar (+ ma1 ma2) sr (sign mar) mar (abs mar))
    (setq dp (- (strLen (fix2str mar)) (+ *sfamsize* dp)))
    (setf mar (sfaTrunc mar))
    (setq pr (+ dp pr))
    (when (< sr 0) (setq mar (- mar)))
    (list mar (if (zerop mar) 0 pr))))

;;   

(defun sfaSub (f1 f2)
  (sfaAdd f1 (sfaNeg f2)))

;;   

(defun sfaDiv (f1 f2)
  (let* ((m1   (nth 0 f1))
         (m2   (nth 0 f2))
         (p1   (nth 1 f1))
         (p2   (nth 1 f2))
         (s1   (sign m1))
         (s2   (sign m2))
         (ma1  (sfaTrunc (abs m1)))
         (ma2  (sfaTrunc (abs m2)))  
         (m    0)
         (r    0)
         (tmp  0)
         (mres 0)
         (pres (+ (if (>= ma1 ma2) 1 0)(- p1 p2)))) 
  (setq mres
      (dotimes (i (+ 2 *sfamsize*) tmp)
         (setq m (\ ma1 ma2) r (% ma1 ma2))
         (setq tmp (str2fix (strCat (fix2str tmp) (fix2str m))))
         (setq ma1 (* r 10))))
  (setq mres (sfaTrunc mres))
  (when (minusp (* s1 s2)) (setq mres (- mres)))
  (list mres (if (zerop mres) 0 pres))))

;;   

(defun sfaMul (f1 f2)
  (let* ((m1   (nth 0 f1))
         (m2   (nth 0 f2))
         (p1   (nth 1 f1))
         (p2   (nth 1 f2))
         (s1   (sign m1))
         (s2   (sign m2))
         (ma1  (sfaTrunc (abs m1)))
         (ma2  (sfaTrunc (abs m2)))  
         (m    0)
         (r    0)
         (tmp  0)
         (mres 0)
         (pres (+ p1 p2 -1)))
  (setq mres (* ma1 ma2)) 
  (when (= (strLen (fix2str mres)) (* 2 *sfamsize*)) (setq pres (+ 1 pres)))
  (setq mres (sfaTrunc mres))
  (when (minusp (* s1 s2)) (setq mres (- mres)))
  (list mres (if (zerop mres) 0 pres))))

;;    

(defun sfaComp (a1 a2)
  (let ((diff (sfaSub a1 a2)))
    (cond ((> (car diff) 0) 1)
          ((zerop (car diff)) 0)
          (t -1))))

;;    

(defun sfaAbs (a)
   (list (abs (car a)) (cadr a)))       

;;      

(defun sfaPow (x n)
 (let ((r '(1 1)))
  (when (> n 0) (iter (for i from 1 to n) (setq r (sfaMul r x)))) r))  

;;    

(defun sfaFact (n)
  (let ((f '(1 1)) (s '(2 1)))
    (when (> n 0) (iter (for i from 2 to n) (setq f (sfaMul f s) s (sfaAdd s '(1 1))))) f))

;;    

(defun [+]   (x y) (sfaAdd x y))
(defun [-]   (x y) (sfaSub x y))
(defun [*]   (x y) (sfaMul x y))
(defun [/]   (x y) (sfaDiv x y))
(defun [>]   (x y) (> (sfaComp x y) 0))
(defun [>=]  (x y) (>= (sfaComp x y) 0))
(defun [<]   (x y) (< (sfaComp x y) 0))
(defun [<=]  (x y) (<= (sfaComp x y) 0))
(defun [^]   (x n) (sfaPow x n))
(defun [abs] (x)   (sfaAbs x))   
(defun [[-]] (x)   (sfaNeg x))

;;       

(defun chk-exp (txt)
  (let ((p 0))
    (iter (for a in-string txt) (if (eq "0" a) (summing 1 into p) (return p)))))

;;       FLOAT   SUPERFLOAT

(defun flo2sup (v)
  (let* ((txt (output v))
         (point (strInd txt "."))
         (exp   (strInd txt "E")))
   (cond ((and (zerop point) (zerop exp))   ;; ----> +/-nnnnnnn
          (list (str2fix txt) (strLen txt)))
         ((zerop exp)                       ;; ----> +/-mmm.nnn 
          (let* ((sign (if (eq "-" (strLeft txt 1)) 
                           (progn (setq txt (strMid txt 2)) (setq point (- point 1)) "-") ""))
                 (ceil  (strLeft txt (- point 1)))
                 (fract (strMid txt (+ 1 point))))
             (cond ((eq ceil "0")           ;; ----> +/-0.nnnn
                    (list  (str2fix (strCat sign fract)) (- (chk-exp fract))))
                   (t (list (str2fix (strCat sign ceil fract)) (- point 1))))))
         (t                                 ;; ----> +/-mmm.nnne+/-pp
             (let* ((sign (if (eq "-" (strLeft txt 1)) 
                           (progn (setq txt (strMid txt 2)) (setq point (- point 1)) (setq exp (- exp 1)) "-") ""))
                    (ceil  (strLeft txt (- point 1)))
                    (fract (strMid txt (+ 1 point) (- exp point 1)))
                    (expp  (strMid txt (+ exp 1))))
             (list (str2fix (strCat sign ceil fract)) (+ (strLen ceil) (str2fix expp))))))))

;;
;;     
;;
;;   

(defun [exp] (x)
   (let ((a   ONE)
         (s   ONE)
         (k   ONE)
         (eps (list 1 (- 1 *sfamsize*))))
     (loop 
         (when ([<] ([abs] a) eps) (return s))
         
         (setq a ([*] a x))
         (setq a ([/] a k))
         (setq k ([+] k ONE))
         (setq s ([+] s a)))))

;;    

(defun [cos] (x)
   (let ((a   ONE)
         (s   ONE)
         (k   ZERO)
         (eps (list 1 (- 1 *sfamsize*))))
     (loop 
        (when ([<] ([abs] a) eps) (return s))
        (setq a ([*] ([*] a x) x)) 
        (setq a ([/] a ([+] k '(1 1)))) 
        (setq a ([/] a ([+] k '(2 1)))) 
        (setq a ([[-]] a))
        (setq s ([+] a s))
        (setq k ([+] k '(2 1))))))

;;    

(defun [sin] (x)
   (let ((a   x)
         (s   x)
         (k   ONE)
         (eps (list 1 (- 1 *sfamsize*))))
     (loop 
        (when ([<] ([abs] a) eps) (return s))
        (setq a ([*] ([*] a x) x)) 
        (setq a ([/] a ([+] k '(1 1)))) 
        (setq a ([/] a ([+] k '(2 1)))) 
        (setq a ([[-]] a))
        (setq s ([+] a s))
        (setq k ([+] k '(2 1))))))

;;     

(defun [sh] (x)
   (let ((a   x)
         (s   x)
         (k   ONE)
         (eps (list 1 (- 1 *sfamsize*))))
     (loop 
        (when ([<] ([abs] a) eps) (return s))
        (setq a ([*] ([*] a x) x)) 
        (setq a ([/] a ([+] k '(1 1)))) 
        (setq a ([/] a ([+] k '(2 1)))) 
        (setq s ([+] a s))
        (setq k ([+] k '(2 1))))))

;;     

(defun [ch] (x)
   (let ((a   ONE)
         (s   ONE)
         (k   ZERO)
         (eps (list 1 (- 1 *sfamsize*))))
     (loop 
        (when ([<] ([abs] a) eps) (return s))
        (setq a ([*] ([*] a x) x)) 
        (setq a ([/] a ([+] k '(1 1)))) 
        (setq a ([/] a ([+] k '(2 1)))) 
        (setq s ([+] a s))
        (setq k ([+] k '(2 1))))))

;;       0.35283402861563771915062078761918845
;;  ==>                 (35283402861563771915062078761918846 0)

(defun [bess] (n x)
    (let ((a   ([/] ONE (sfaFact n)))
          (s   ZERO)
          (k   ZERO)
          (eps (list 1 (- 1 *sfamsize*))))
      (loop 
          (when ([<=] ([abs] a) eps) (return t))
          (setq s ([+] s a))
          (setq k ([+] ONE k))
          (setq a ([[-]] ([/] ([*] ([*] a x) x) ([*] k ([*] ([+] (flo2sup n) k) FOUR))))))
      (iter (for _ from 1 to n) (setq s ([*] s ([*] x '(5 0)))))
      s))

